function love.load()
	tilemap = {};
	
	tilemap.map = {
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 2, 0, 1, 1, 1, 1, 0, 3, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 2, 0, 1, 1, 1, 1, 1, 1, 0, 3, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 2, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 3, 0, 0, 0, 0, 0, 1},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
	};
	tilemap.map.tileW = 32;
	tilemap.map.tileH = 32;
	
	tilemap.map.wall = love.graphics.newImage("wall.png");
	tilemap.map.door = love.graphics.newImage("door.png");
	tilemap.map.slope_l = love.graphics.newImage("slope_l.png");
	tilemap.map.slope_r = love.graphics.newImage("slope_r.png");
	
	delta = 0.5;
	
	p = {};
	
	p.img = love.graphics.newImage("player.png");
	
	p.w = 32;
	p.h = 32;
	
	p.xtile = 2;
	p.ytile = 1;
	
	p.x = p.xtile * tilemap.map.tileW + tilemap.map.tileW;
	p.y = (p.ytile + 1) * tilemap.map.tileH + tilemap.map.tileH;
	
	p._x = p.x;
	p._y = p.y;
	
	p.speed = 150;
	
	gravity = 550; -- 350
	maxJump = -300;
	jumpSpeed = 100;
	p.ySpeed = 0;
	
	p.onFloor = false;
	
	dirx = 0;
	p.onSlope = false;
	
	state = "";
	
end

function love.keypressed(key)
	if key == "left" then
		dirx = -1;
	elseif key == "right" then
		dirx = 1;
	end
	
	if key == "x" or key == " " then
		PlayerJump();
	end
end

function love.keyreleased(key)
	if key == "left" then
		dirx = 0;
	elseif key == "right" then
		dirx = 0;
	end
end

function love.update(dt)
	delta = dt;
	
	p_update(dt);
end

function love.draw()
	tilemap_draw();
	
	love.graphics.print("state: " .. state, 10, 10);
	
	p_draw();
end

-- ============================= player ========================================

function p_update(dt)
	local halfX = p.w - 1;
	local halfY = p.h - 1;
	
	--local dirx = 0;
	local diry = 0;
	
	-- apply gravity
	p.ySpeed = p.ySpeed + (gravity * dt);
	
	-- calculate vertical position and adjust if needed
	local nextY = p.y + (p.ySpeed * dt);
	if p.ySpeed > 0 then -- down
		diry = 1;
		if not(isCollider(p.x + halfX, nextY + halfY, 1)) and not(isCollider(p.x, nextY + halfY, 1)) then
			-- no collision, move normally
			p.y = nextY;
			p.onFloor = false;
		else
			p.ySpeed = 0;
			p.onFloor = true;
		end
	elseif p.ySpeed < 0 then -- up
		diry = -1;
		if not(isCollider(p.x + halfX, nextY, 1)) and not(isCollider(p.x, nextY, 1)) then
			-- no collision, move normally
			p.y = nextY;
			p.onFloor = false;
		else
			p.ySpeed = 0;
		end
	end
	
	-- calculate horizontal position and adjust if needed
	if dirx == -1 then
		local nextX = p.x - p.speed * dt;
		if not(isCollider(nextX, p.y, 1))
			and not(isCollider(nextX, p.y + halfY, 1)) then
			p.x = nextX;
		end
	elseif dirx == 1 then
		local nextX = p.x + p.speed * dt;
		if not(isCollider(nextX + halfX, p.y, 1))
			and not(isCollider(nextX + halfX, p.y + halfY, 1)) then
			p.x = nextX;
		end
	end
	
	p.xtile = math.floor(p.x / tilemap.map.tileW);
    p.ytile = math.floor(p.y / tilemap.map.tileH);
	
	p._x = p.x;
	p._y = p.y;
	
	checkForSlopes(diry, dirx);
	
end

function PlayerJump()
	if p.onFloor then
		p.ySpeed = maxJump;
		p.onFloor = false;
	end
end

-- returns true if the coordinates given intersect a map tile
function isCollider(x, y, id)
	local tileID = 1 or id;

    -- get tile coordinates
    local tileX =  math.floor(x / tilemap.map.tileW);
	local tileY = math.floor(y / tilemap.map.tileH);
    
    -- grab the tile at given point
    if tilemap.map[tileY][tileX] == tileID then
		return true;
	end
    
    -- return true if the point overlaps a solid tile
    return false;
end

function checkForSlopes(diry, dirx)
	if tilemap.map[p.ytile + 1][p.xtile] == 2 then
		p.ytile = p.ytile + 1;
        p.y = p.y + tilemap.map.tileH;
	end
	
	if tilemap.map[p.ytile][p.xtile] == 2 and diry ~= -1 then
		
		if diry == 1 then
            -- p.y = (p.ytile + 1) * tilemap.map.tileH - (p.h + 32);
			p.y = (p.ytile + 1) * tilemap.map.tileH - (p.h + 32);
        end
		
		local xpos = p.x - p.xtile * tilemap.map.tileW;
        p.onSlope = tilemap.map[p.ytile][p.xtile] == 2;
		
		if tilemap.map[p.ytile][p.xtile] == 2 then
			-- up left 4
            p.addy = xpos;
            p._y = ((p.ytile + 1) * tilemap.map.tileH) - p.h - p.addy;
		end
	else
		-- (p.onSlope == true and dirx == 1) or 
		if (p.onSlope == true and dirx == 1) or (p.onSlope == true and dirx == -1) then
			p.ytile = p.ytile - 1;
            p.y = p.y - tilemap.map.tileH;
            p._y = p.y;
		end
		
		p.onSlope = false;
	end
end

function p_draw()
	love.graphics.draw(p.img, p._x, p._y);
end

-- ============================== tilemap ======================================

function tilemap_draw()
	for y = 1, #tilemap.map do
		for x = 1, #tilemap.map[1] do
			if tilemap.map[y][x] == 1 then
				love.graphics.draw(tilemap.map.wall, x * tilemap.map.tileW, y * tilemap.map.tileH);
			end
			
			if tilemap.map[y][x] == 2 then
				love.graphics.draw(tilemap.map.slope_l, x * tilemap.map.tileW, y * tilemap.map.tileH);
			end
			
			if tilemap.map[y][x] == 3 then
				love.graphics.draw(tilemap.map.slope_r, x * tilemap.map.tileW, y * tilemap.map.tileH);
			end
			
			if tilemap.map[y][x] == 4 then
				love.graphics.draw(tilemap.map.door, x * tilemap.map.tileW, y * tilemap.map.tileH);
			end
		end
	end
end









































